' Aufg18.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Temperatur

	Public Const FAHRENHEIT As Integer = 0
	Public Const RANKINE As Integer = 1
	Public Const CELSIUS As Integer = 2
	Public Const KELVIN As Integer = 3
	Public Const REAUMUR As Integer = 4

	Public Shared Function ToCelsius(ByVal wert As Double, ByVal einheit As Integer) As Double
		Select Case einheit
			Case FAHRENHEIT
				Return (wert - 32.0) * 5.0 / 9.0
			Case RANKINE
				Return wert * 5.0 / 9.0 - 273.15
			Case CELSIUS
				Return wert
			Case KELVIN
				Return wert - 273.15
			Case REAUMUR
				Return wert * 4.0 / 5.0
			Case Else
				Return wert
		End Select
	End Function

	Private Sub New()
	End Sub
End Class

Public Module Aufg18

	Public Sub Main()
		Console.WriteLine(Temperatur.ToCelsius(99.7, Temperatur.FAHRENHEIT))
		Console.WriteLine(Temperatur.ToCelsius(671.67, Temperatur.RANKINE))
		Console.WriteLine(Temperatur.ToCelsius(37.5, Temperatur.CELSIUS))
		Console.WriteLine(Temperatur.ToCelsius(273.15, Temperatur.KELVIN))
		Console.WriteLine(Temperatur.ToCelsius(100, Temperatur.REAUMUR))
		Console.WriteLine(Temperatur.ToCelsius(100, 5))
		' Dim T As New Temperatur
	End Sub
End Module
