' Bspl043.vb

Option Explicit On 
Option Strict On

Imports System
Imports Microsoft.VisualBasic

Public Class Temperatur

	Private TempWert As Integer
	Private Const Nullpunkt As Double = -273.15

	Public Sub New(ByVal initWert As Integer)	'(1)
		Wert = initWert		  '(2)
	End Sub

	Public Property Wert() As Integer
		Set(ByVal value As Integer)
			TempWert = CInt(IIf(value > Nullpunkt, value, 0))
		End Set
		Get
			Return TempWert
		End Get
	End Property
	Public Function ToFahrenheit() As Double
		Return 9.0 / 5.0 * Wert + 32
	End Function
	Public Function ToKelvin() As Double
		Return Wert - Nullpunkt
	End Function

End Class


Public Module Bspl043

	Public Sub Main()
		Dim Tagestemp As Temperatur
		Tagestemp = New Temperatur(-300)		  '(3)
		Dim Nachttemp As New Temperatur(14)
		Console.WriteLine(Tagestemp.Wert)
		Console.WriteLine(Tagestemp.ToFahrenheit())
		Console.WriteLine(Tagestemp.ToKelvin())
	End Sub
End Module
