' Bspl053.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto

	Private Stand As Decimal
	Private Inhaber As String
	Public Const EUR As Integer = 0	'(1)
	Public Const USD As Integer = 1
	Public Shared Zins As Decimal	 '(2)

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand = betrag
	End Sub

	Public Sub AddZinsen()	 '(3)
		Einzahlen(Stand * Zins)
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)
		Stand += betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal, _
	 ByVal waehrung As Integer)	 '(4)
		If (waehrung = USD) Then		'(5)
			Einzahlen(betrag / 1.1591D)
		Else
			Einzahlen(betrag)
		End If
	End Sub
End Class

Public Module Bspl053
	Public Sub Main()
		Konto.Zins = 1.5D / 100		'(7)
		Dim Konto1 As New Konto("H. Meier", 1000D)
		Console.WriteLine(Konto.Zins)		  '(8)
		Console.WriteLine("{0:0.00}", Konto1.Saldo)
		Konto1.AddZinsen()
		Console.WriteLine("{0:0.00}", Konto1.Saldo)
		Konto1.Einzahlen(1000D, Konto.USD)		  '(9)
		Console.WriteLine("{0:0.00}", Konto1.Saldo)
	End Sub
End Module
