' Bspl055.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto

	Private Stand As Decimal
	Private Inhaber As String
	Public Shared Kurs As Decimal	'(1)

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand = betrag
	End Sub

	Public Function ToUSD() As Decimal	  '(2)
		Return Stand * Kurs
	End Function

	Public Shared Function ToUSD( _
	 ByVal betrag As Decimal) As Decimal	'(3)
		Return betrag * Kurs
	End Function

	Public Shared Function ToEuro( _
	 ByVal betrag As Decimal) As Decimal	 '(4)
		Return betrag / Kurs
	End Function
End Class

Public Class Bspl055 '(5)
	Public Shared Sub Main()	'(6)
		Konto.Kurs = 1.1591D
		Dim Konto1 As New Konto("Mustermann", 1000D)
		Console.WriteLine("{0:#,##0.00}", Konto1.Saldo)
		Console.WriteLine("{0:#,##0.00}", Konto1.ToUSD())		 '(7)
		Console.WriteLine("{0:#,##0.00}", _
		 Konto.ToUSD(1955.83D))		  '(8)
		Console.WriteLine("{0:#,##0.00}", _
		Konto.ToEuro(511.29D))		  '(9)
	End Sub
End Class
