' Bspl057.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Form

	Private Color As Integer	 '(1)
	Public Const Rot As Integer = 1	'(2)
	Public Const Gruen As Integer = 2
	Public Const Blau As Integer = 4

	Public Property Farbe() As Integer	'(3)
		Get
			Return Color
		End Get
		Set(ByVal value As Integer)
			If value < 8 Then Color = value
		End Set
	End Property

	Public Function FarbeToString() As String	 '(4)
		Select Case Color
			Case 0			'(5)
				Return "schwarz"
			Case 1			'(6)
				Return "rot"
			Case 2
				Return "grn"
			Case 3			'(7)
				Return "gelb"
			Case 4
				Return "blau"
			Case 5
				Return "magenta"
			Case 6
				Return "cyan"
			Case 7
				Return "wei"
			Case Else			 '(8)
				Return "unbekannt"
		End Select
	End Function
End Class


Public Class Rechteck : Inherits Form '(9)

	Private A, B As Integer	 '(10)

	Public Sub New(ByVal a As Integer, ByVal b As Integer)	'(11)
		Me.A = a
		Me.B = b
	End Sub

	Public ReadOnly Property Flaeche() As Long	 '(12)
		Get
			Return A * B
		End Get
	End Property
End Class


Public Module Bspl057

	Public Sub Main()
		Dim R As New Rechteck(10, 5)		   '(13)
		Console.WriteLine(R.Flaeche)		  '(14)
		Console.WriteLine(R.FarbeToString())		  '(15)
		R.Farbe = Form.Rot Or Form.Blau		  '(16)
		Console.WriteLine(R.FarbeToString())		  '(17)
	End Sub
End Module
