' Bspl058.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Form

	Private Color As Integer
	Public Const Rot As Integer = 1
	Public Const Gruen As Integer = 2
	Public Const Blau As Integer = 4

	Public Property Farbe() As Integer
		Get
			Return Color
		End Get
		Set(ByVal value As Integer)
			If value < 8 Then Color = value
		End Set
	End Property

	Public Function FarbeToString() As String
		Select Case Color
			Case 0
				Return "schwarz"
			Case 1
				Return "rot"
			Case 2
				Return "grn"
			Case 3
				Return "gelb"
			Case 4
				Return "blau"
			Case 5
				Return "magenta"
			Case 6
				Return "cyan"
			Case 7
				Return "wei"
			Case Else
				Return "unbekannt"
		End Select
	End Function
End Class

Public Module Bspl058

	Public Sub Main()
		Dim F1 As New Form		'(1)
		Dim F2 As New Form
		Dim F3 As Form = F1		'(2)
		Console.WriteLine(F1.ToString())		  '(3)
		Console.WriteLine(F2.ToString())
		Console.WriteLine(F1.Equals(F2))		  '(4)
		Console.WriteLine(F1.Equals(F3))		  '(5)
	End Sub
End Module
