' Bspl059.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Form

	Private Color As Integer
	Public Const Rot As Integer = 1
	Public Const Gruen As Integer = 2
	Public Const Blau As Integer = 4

	Public Sub New(ByVal f As Integer)	'(1)
		Color = f
	End Sub

	Public Sub New()	  '(2)
	End Sub

	Public Property Farbe() As Integer
		Get
			Return Color
		End Get
		Set(ByVal value As Integer)
			If value < 8 Then Color = value
		End Set
	End Property

	Public Function FarbeToString() As String
		Select Case Color
			Case 0
				Return "schwarz"
			Case 1
				Return "rot"
			Case 2
				Return "grn"
			Case 3
				Return "gelb"
			Case 4
				Return "blau"
			Case 5
				Return "magenta"
			Case 6
				Return "cyan"
			Case 7
				Return "wei"
			Case Else
				Return "unbekannt"
		End Select
	End Function
End Class


Public Class Rechteck : Inherits Form

	Private A, B As Integer

	Public Sub New(ByVal a As Integer, ByVal b As Integer)   '(4)
		Me.A = a
		Me.B = b
	End Sub

	Public ReadOnly Property Flaeche() As Long
		Get
			Return A * B
		End Get
	End Property
End Class


Public Module Bspl059

	Public Sub Main()
		Dim R As New Rechteck(10, 5)		   '(5)
		Console.WriteLine(R.Flaeche)
		Console.WriteLine(R.FarbeToString())
		R.Farbe = Form.Rot Or Form.Blau
		Console.WriteLine(R.FarbeToString())
	End Sub
End Module
