' Bspl061.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Form

	Private Color As Integer
	Public Const Rot As Integer = 1
	Public Const Gruen As Integer = 2
	Public Const Blau As Integer = 4

	Public Sub New(ByVal f As Integer)
		Color = f
	End Sub

	Public Sub New()
	End Sub

	Public Property Farbe() As Integer
		Get
			Return Color
		End Get
		Set(ByVal value As Integer)
			If value < 8 Then Color = value
		End Set
	End Property

	Public Function FarbeToString() As String
		Select Case Color
			Case 0
				Return "schwarz"
			Case 1
				Return "rot"
			Case 2
				Return "grn"
			Case 3
				Return "gelb"
			Case 4
				Return "blau"
			Case 5
				Return "magenta"
			Case 6
				Return "cyan"
			Case 7
				Return "wei"
			Case Else
				Return "unbekannt"
		End Select
	End Function
End Class

Public Class Kreis : Inherits Form '(2)

	Protected R As Integer	  '(3)

	Public Sub New(ByVal r As Integer)	'(4)
		Me.R = r
	End Sub

	Public Sub New()	 '(5)
	End Sub

	Public ReadOnly Property Flaeche() As Double	   '(6)
		Get
			Return Math.PI * Math.Pow(R, 2)
		End Get
	End Property
End Class

Public Class Ring
	Inherits Kreis	  '(7)

	Private L As Double	  '(8)

	Public Sub New(ByVal r As Integer, ByVal l As Double)	'(9)
		Me.R = r		 '(10)
		Me.L = l		  '(11)
	End Sub

	Public Shadows ReadOnly Property Flaeche() As Double	   '(12)
		Get
			Return Math.PI * Math.Pow(R, 2) - _
			 Math.PI * Math.Pow(L, 2)
		End Get
	End Property
End Class

Module Bspl061
	Public Sub Main()
		Dim R As New Ring(10, 5)		 '(13)
		Console.WriteLine(R.Flaeche)		   '(14)
	End Sub
End Module
