' Bspl066.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto '(1)

	Private Stand As Decimal
	Private Inhaber As String
	Public Shared Kurs As Decimal

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String, _
	 ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand = betrag
	End Sub

	Public Function ToUSD() As Decimal
		Return Stand * Kurs
	End Function

	Public Shared Function ToUSD( _
	 ByVal betrag As Decimal) As Decimal
		Return betrag * Kurs
	End Function

	Public Shared Function ToEuro( _
	 ByVal betrag As Decimal) As Decimal
		Return betrag / Kurs
	End Function
End Class

Public Delegate Function Delegierer1(ByVal betrag As Decimal) As Decimal   '(2)
Public Delegate Function Delegierer2() As Decimal '(3)

Public Module Bspl066
	Public Sub Main()
		Dim K As New Konto("Max", 345D)
		Konto.Kurs = 1.1591D
		Dim D1 As Delegierer1		  '(4)
		Dim D2 As Delegierer2
		D1 = New Delegierer1(AddressOf Konto.ToEuro)		  '(5)
		Console.WriteLine("{0:0.00}", D1.Invoke(1955.83D))		 '(6)
		D2 = AddressOf K.ToUSD		  '(7)
		Console.WriteLine("{0:0.00}", D2())		 '(8)
	End Sub
End Module
