' Bspl070.vb

Option Explicit On
Option Strict On

Imports System

Public Class Konto 		'(1)

	Private Stand As Decimal
	Private Inhaber As String
	Private Minimum As Decimal = 100D

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand = betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)
		Stand += betrag
	End Sub

	Public Sub Auszahlen(ByVal betrag As Decimal)
		If Stand >= betrag Then Stand -= betrag
		If Stand <= Minimum Then
			RaiseEvent SaldoWarnung(Me, EventArgs.Empty)			   '(2)
		End If
	End Sub

	Public Event SaldoWarnung As EventHandler	'(3)
End Class

Public Class Kunde   '(4)

	Public Sub Reaktion(ByVal k As Object, ByVal e As EventArgs) '(5)
		Dim Giro As Konto = CType(k, Konto)		  '(6)
		Giro.Einzahlen(1000D)	   '(7)
	End Sub

End Class

'Public Delegate Sub Zahlung()	'(8)

Public Module Bspl070
	Public Sub Main()
		Dim K As New Kunde
		Dim Giro As New Konto("Schulze", 3000D)
		AddHandler Giro.SaldoWarnung, AddressOf K.Reaktion		  '(9)
		Giro.Auszahlen(2000D)
		Console.WriteLine(giro.Saldo)
		Giro.Auszahlen(500D)
		Console.WriteLine(giro.Saldo)
		Giro.Auszahlen(430D)
		Console.WriteLine(giro.Saldo)
		Giro.Auszahlen(50D)
		Console.WriteLine(giro.Saldo)
	End Sub
End Module
