' Aufg15.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Nahrungsmittel

	Private Bez As String
	Private Kal As Integer

	Public Property Name() As String
		Get
			Return Bez
		End Get
		Set(ByVal value As String)
			Bez = value
		End Set
	End Property

	Public Property Brennwert() As Integer
		Get
			Return Kal
		End Get
		Set(ByVal value As Integer)
			If value >= 0 Then
				Kal = value
			End If
		End Set
	End Property

	Public Function ToJoule() As Single
		Return Brennwert * 4.1868F
	End Function

	Public Sub New(ByVal name As String)
		Me.New(name, 0)
	End Sub

	Public Sub New(ByVal brennwert As Integer)
		Me.New("unbekannt", brennwert)
	End Sub

	Public Sub New(ByVal name As String, ByVal brennwert As Integer)
		Bez = name
		Kal = brennwert
	End Sub

	Protected Overrides Sub Finalize()
	End Sub
End Class



Public Module Aufg15

	Sub Main()
		Dim Menue As Nahrungsmittel = New Nahrungsmittel(64)
		Console.WriteLine(Menue.Name & " hat " & Menue.Brennwert & " kcal")
		Console.WriteLine("Das sind " & Menue.ToJoule() & " kJ")
	End Sub

End Module
