' Aufg17.vb

Option Explicit On 
Option Strict On

Imports System
Imports Microsoft.VisualBasic

Public Class Konto

	Private Stand As Decimal
	Private Inhaber As String

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String)
		Me.new(inhaber, 0)
	End Sub

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand += betrag + 10
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)
		Stand += betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal, ByVal waehrung As String)
		If waehrung = "USD" Then
			Einzahlen(betrag * 1.1591D)
		Else
			Einzahlen(betrag)
		End If
	End Sub

	Public Sub Einzahlen(ByVal betrag() As Double)
		For i As Integer = 0 To betrag.Length - 1
			Einzahlen(CDec(betrag(i)))
		Next
	End Sub

	Public Sub Einzahlen(ByVal ParamArray betrag() As Decimal)
		For i As Integer = 0 To betrag.Length - 1
			Einzahlen(betrag(i))
		Next
	End Sub

	Public Sub Einzahlen(ByVal betrag As String)
		Stand += CDec(betrag)
	End Sub

	Public Sub Auszahlen(ByVal betrag As Decimal)
		If Stand >= betrag Then
			Stand -= betrag
		End If
	End Sub

	Public Sub Auszahlen(ByVal betrag As String)
		If Stand >= CDec(Val(betrag)) Then
			Stand -= CDec(Val(betrag))
		End If
	End Sub
End Class

Public Module Aufg17
	Public Sub Main()
		Dim Konto1 As New Konto("H. Meier", 500D)
		Console.WriteLine(Konto1.Saldo)
		Konto1.Einzahlen("411,50")
		Console.WriteLine(Konto1.Saldo)
		Konto1.Auszahlen("750")
		Console.WriteLine(Konto1.Saldo)
	End Sub
End Module
