' Aufg20.vb

Option Explicit On 
Option Strict On

Imports System

Public MustInherit Class Form '(1)

	Private Color As Integer
	Public Const Rot As Integer = 1
	Public Const Gruen As Integer = 2
	Public Const Blau As Integer = 4

	Public Property Farbe() As Integer
		Get
			Return Color
		End Get
		Set(ByVal value As Integer)
			If value < 8 Then Color = value
		End Set
	End Property

	Public Function FarbeToString() As String
		Select Case Color
			Case 0
				Return "schwarz"
			Case 1
				Return "rot"
			Case 2
				Return "grn"
			Case 3
				Return "gelb"
			Case 4
				Return "blau"
			Case 5
				Return "magenta"
			Case 6
				Return "cyan"
			Case 7
				Return "wei"
			Case Else
				Return "unbekannt"
		End Select
	End Function

	Public Overridable ReadOnly Property Flaeche() As Double
		Get
			Return 0
		End Get
	End Property

	Public Overridable ReadOnly Property Umfang() As Double
		Get
			Return 0
		End Get
	End Property
End Class

Public Class Rechteck : Inherits Form

	Private A, B As Integer

	Public Sub New(ByVal a As Integer, ByVal b As Integer)
		Me.A = a
		Me.B = b
	End Sub

	Public Overrides ReadOnly Property Flaeche() As Double
		Get
			Return A * B
		End Get
	End Property

	Public Overrides ReadOnly Property Umfang() As Double
		Get
			Return 2 * (A + B)
		End Get
	End Property
End Class

Public Class Quadrat : Inherits Rechteck

	Public Sub New(ByVal a As Integer)
		MyBase.New(a, a)
	End Sub
End Class

Module Aufg20
	Public Sub Main()
		Dim R As New Rechteck(5, 2)
		Dim Q As New Quadrat(4)
		R.Farbe = Form.Gruen
		Q.Farbe = Form.Rot
		Console.WriteLine(R.Flaeche)
		Console.WriteLine(R.Umfang)
		Console.WriteLine(R.FarbeToString())
		Console.WriteLine(Q.Flaeche)
		Console.WriteLine(Q.Umfang)
		Console.WriteLine(Q.FarbeToString())
	End Sub
End Module
