' Bspl041.vb

Option Explicit On 
Option Strict On

Imports System
Imports Microsoft.VisualBasic

Public Class Temperatur  '(1)

	Private Wert As Integer	  '(2)

	Public Sub SetWert( _
	 ByVal neuerWert As Integer)	'(3)
		Wert = CInt(IIf(neuerWert > -273, _
		 neuerWert, 0))		  '(4)
	End Sub
	Public Function GetWert() As Integer	'(5)
		Return Wert
	End Function
	Public Function ToFahrenheit() As Double
		Return 9.0 / 5.0 * Wert + 32
	End Function
	Public Function ToKelvin() As Double
		Return Wert + 273.15
	End Function

End Class


Public Module Bspl041  '(6)

	Public Sub Main()	 '(7)
		Dim Tagestemp As Temperatur
		Tagestemp = New Temperatur
		Tagestemp.SetWert(32)		  '(8)
		Dim Nachttemp As New Temperatur
		Nachttemp.SetWert(14)
		Console.WriteLine(Tagestemp.GetWert())		  '(9)
		Console.WriteLine(Tagestemp.ToFahrenheit())
		Console.WriteLine(Tagestemp.ToKelvin())
	End Sub
End Module
