' Bspl046.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Absatz

	Private ReadOnly SEZ() As Char = _
	 {"."c, "?"c, "!"c}	 '(1)
	Private Saetze() As String	'(2)

	Public Property Text() As String	  '(3)
		Get
			Return String.Join(" ", Saetze)			'(4)
		End Get
		Set(ByVal value As String)
			Saetze = value.Split(SEZ)			 '(5)
			For i As Integer = 0 _
			 To Saetze.Length - 2			 '(6)
				Dim pos As Integer = _
				 Convert.ToInt32( _
				 value.IndexOf(Saetze(i)) _
				  + Saetze(i).Length)				   '(7)
				Saetze(i) = Saetze(i).Trim() _
				 & value.Substring(pos, 1)				  '(8)
			Next
		End Set
	End Property

	Default Public Property Satz( _
	 ByVal i As Integer) As String	'(9)
		Get		  '(10)
			If i >= 0 And _
			 i < Saetze.Length - 1 Then			'(11)
				Return Saetze(i)
			Else
				Return ""
			End If
		End Get
		Set(ByVal value As String)		  '(12)
			If i >= 0 And _
			 i < Saetze.Length - 1 Then
				Saetze(i) = value				 '(13)
			End If
		End Set
	End Property
End Class

Public Module Bspl046
	Public Sub Main()
		Dim A As New Absatz		   '(14)
		A.Text = "Dies ist ein Test. Gelingt " _
		 & "er? Das hoffe ich!"		  '(15)
		Console.WriteLine(A.Text)
		Console.WriteLine(A(0))		  '(16)
		Console.WriteLine(A(1))
		Console.WriteLine(A(2))
		A(0) = "Das war's."		 '(17)
		A(1) = "Prima!"
		A(2) = "Jetzt ist Schluss."
		Console.WriteLine(A.Text)
		Console.WriteLine(A(0))
		Console.WriteLine(A(1))
		Console.WriteLine(A(2))
	End Sub
End Module
