' Bspl048.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto

	Private Stand As Decimal

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub Einzahlen(ByVal betrag As Decimal)	'(1)
		Stand += betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal, _
	 ByVal waehrung As String)	   '(2)
		If waehrung = "USD" Then
			Stand += betrag / 1.1591D
		Else
			Stand += betrag
		End If
	End Sub

	Public Sub Einzahlen(ByVal betrag() As Double)	'(3)
		For i As Integer = 0 To betrag.Length - 1
			Stand += CDec(betrag(i))
		Next
	End Sub

	Public Sub Einzahlen(ByVal ParamArray betrag() As Decimal)	'(4)
		For i As Integer = 0 To betrag.Length - 1
			Stand += betrag(i)
		Next
	End Sub
End Class

Public Module Bspl048

	Public Sub Main()
		Dim Liste() As Double = {11.3, 24.5, 9.99}		  '(5)
		Dim MeinKonto As New Konto
		MeinKonto.Einzahlen(45.99D)		  '(6)
		MeinKonto.Einzahlen(Liste)		  '(7)
		MeinKonto.Einzahlen(10D, "USD")		 '(8)
		MeinKonto.Einzahlen(23.7D, 56D, 23.89D)		'(9)
		Console.WriteLine("{0:0.00}", MeinKonto.Saldo)
	End Sub
End Module
