' Bspl053a.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Konto

	Private Stand As Decimal
	Private Inhaber As String
	Public Const EUR As Integer = 0
	Public Const USD As Integer = 1
	Public Shared Zinssatz As Decimal	 '(1)

	Public Shared Property Zins() As Decimal	  '(2)
		Get
			Return Zinssatz
		End Get
		Set(ByVal value As Decimal)
			If value >= 0 And value <= 0.1 Then		   '(3)
				Zinssatz = value
			End If
		End Set
	End Property

	Public ReadOnly Property Saldo() As Decimal
		Get
			Return Stand
		End Get
	End Property

	Public Sub New(ByVal inhaber As String, ByVal betrag As Decimal)
		Me.Inhaber = inhaber
		Stand = betrag
	End Sub

	Public Sub AddZinsen()	 '(3)
		Einzahlen(Stand * Zins)
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal)
		Stand += betrag
	End Sub

	Public Sub Einzahlen(ByVal betrag As Decimal, _
	 ByVal waehrung As Integer)
		If (waehrung = USD) Then
			Einzahlen(betrag / 1.1591D)
		Else
			Einzahlen(betrag)
		End If
	End Sub
End Class

Public Module Bspl053a
	Public Sub Main()
		Konto.Zins = 1.5D / 100		'(4)
		Dim Konto1 As New Konto("H. Meier", 1000D)
		Console.WriteLine(Konto.Zins)
		Console.WriteLine("{0:0.00}", Konto1.Saldo)
		Konto1.AddZinsen()
		Console.WriteLine("{0:0.00}", Konto1.Saldo)
		Konto1.Einzahlen(1000D, Konto.USD)
		Console.WriteLine("{0:0.00}", Konto1.Saldo)
	End Sub
End Module
