' Bspl067.vb

Option Explicit On 
Option Strict On

Imports System

Public Class Person  '(1)

	Private Geburt As DateTime	 '(2)

	Public Sub New(ByVal d As DateTime)	'(3)
		Geburt = d
	End Sub

	Public Function Alter(ByVal wert As DateTime) As Integer	'(4)
		Return (wert.Subtract(Geburt)).Days		  '(5)
	End Function

	Public Shared Function Dauer(ByVal wert As DateTime) As Integer	'(6)
		Return (DateTime.Today.Subtract(wert)).Days		  '(7)
	End Function
End Class

Public Class Kalender '(8)


	Public Shared Function Tage(ByVal wert As DateTime) As Integer	'(9)
		Return wert.Year * 365 + wert.Month * 30 _
		  + wert.Day		  '(10)
	End Function

End Class
Public Delegate Function Delegierer(ByVal d As DateTime) As Integer '(11)

Public Module Bspl067
	Public Sub Main()
		Dim d(2) As Delegierer		   '(12)
		Dim P As New Person(New DateTime(1970, 11, 4))		 '(13)
		d(0) = AddressOf P.Alter		  '(14)
		d(1) = AddressOf Person.Dauer		  '(15)
		d(2) = AddressOf Kalender.Tage		  '(16)
		For i As Integer = 0 To d.Length - 1		  '(17)
			'Console.WriteLine(d(i)(DateTime.Today))			 '(18)
			' alternativ
			Console.WriteLine(StartMethode(d(i)))
		Next
	End Sub
	Private Function StartMethode(ByVal d As Delegierer) As Integer '(2)
		Return d(DateTime.Today)	   '(3)
	End Function
End Module
